﻿using System;
using System.Collections.Generic;

namespace Cpn.Sensor
{
  public class CalibValues
  {
    public double CurrentZero;
    public double CurrentSpan;
    public double ConcentrationZero;
    public double ConcentrationSpan;

    public static CalibValues FromMessageValues ( IReadOnlyList<double> values )
    {
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      var calib = new CalibValues();
      calib.CurrentZero = values[0];
      calib.CurrentSpan = values[1];
      calib.ConcentrationZero = values[2];
      calib.ConcentrationSpan = values[3];
      return calib;
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    }


    public IReadOnlyList<double> ToMessageValues ()
    {
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      var values = new List<double>();
      values.Add ( CurrentZero );
      values.Add ( CurrentSpan );
      values.Add ( ConcentrationZero );
      values.Add ( ConcentrationSpan );
      return values;
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    }


    public void WriteValuesToConsole ()
    {
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      Console.WriteLine ( "Compensated current ZERO gas point : {0,8:F2} pA", CurrentZero );
      Console.WriteLine ( "Compensated current SPAN gas point : {0,8:F2} pA", CurrentSpan );
      Console.WriteLine ( "Concentration ZERO gas point       : {0,8:F2} ppm", ConcentrationZero );
      Console.WriteLine ( "Concentration SPAN gas point       : {0,8:F2} ppm", ConcentrationSpan );
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    }
  }
}
