﻿//-----------------------------------------------------------------------------
// ACI PIM CPN Sensor sample program
// Cpn sensor device library
//-----------------------------------------------------------------------------
// 2020 Analytical Control Instruments GmbH
//-----------------------------------------------------------------------------


using System;

namespace Cpn.Sensor.Communication
{
  public partial class Message
  {
    /// <summary>Maximum size of command part of message</summary>
    public static int CommandSize => 32;
    /// <summary>Maximum size of parameter part of message</summary>
    public static int ParameterSize => 256;


    /// <summary>Address part of message</summary>
    public static UInt32 Address => 0x00000000U;

    public static string AddressHexString => Address.ToString ( "X08" );


    public string Command { get; set; } = string.Empty;

    public string Parameter { get; set; } = string.Empty;

    public string Complete
    {
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      get
      {
        if ( string.IsNullOrEmpty ( Parameter ) ) return Command;
        return Command + CharSEP + Parameter;
      }

      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      set
      {
        Command = string.Empty;
        Parameter = string.Empty;

        var ars = value.Split ( new char[] {CharSEP}, 2 );

        if ( 1 == ars.Length ) { Command = ars[0]; }
        else if ( 2 == ars.Length ) { Command = ars[0]; Parameter = ars[1]; }
        else throw new Exception ( "Invalid mesage format" );
      }
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    }
  }
}
