﻿//-----------------------------------------------------------------------------
// ACI PIM CPN Sensor sample program
// Cpn sensor device library
//-----------------------------------------------------------------------------
// 2020 Analytical Control Instruments GmbH
//-----------------------------------------------------------------------------


using System.ComponentModel;
using Cpn.Sensor.Communication;


namespace Cpn.Sensor
{
  public partial class Device : Component
  {
    /// <summary>Identify a module on a port.</summary>
    /// <param name="portname">Port name to identify.</param>
    /// <returns>True if module is on this port otherwise false.</returns>
    public static bool Identify ( string portname )
    {
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      using ( var port = new DevicePort ( portname ) )
      {
        try
        {
          port.Open ();
          var txmsg = new Message( "device ?");
          var rxmsg = port.Transmit(txmsg, DevicePort.DefaultReadDelay);

          return "CPN Sensor Device" == rxmsg.Parameter;
        }
        catch
        {
          return false;
        }
      }
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    }
  }
}
