﻿//-----------------------------------------------------------------------------
// ACI PIM CPN Sensor sample program
// Cpn sensor device library
//-----------------------------------------------------------------------------
// 2020 Analytical Control Instruments GmbH
//-----------------------------------------------------------------------------


using System.ComponentModel;
using Cpn.Sensor.Communication;


namespace Cpn.Sensor
{
  public partial class Device : Component
  {
    /// <summary>Transmit a message to device.</summary>
    /// <param name="txmsg">Message to send.</param>
    /// <returns>Message received.</returns>
    public Message Transmit ( Message txmsg )
    {
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      return Port.Transmit ( txmsg, DevicePort.DefaultReadDelay );
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    }


    /// <summary>Transmit a message to device.</summary>
    /// <param name="complete">Complete message text to send.</param>
    /// <returns>Message received.</returns>
    public Message Transmit ( string command, string parameter )
    {
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      var txmsg = new Message();
      txmsg.Command = command;
      txmsg.Parameter = parameter;

      return Port.Transmit ( txmsg, DevicePort.DefaultReadDelay );
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    }


    /// <summary>Transmit a message to device.</summary>
    /// <param name="complete">Complete message text to send.</param>
    /// <returns>Message received.</returns>
    public Message Transmit ( string complete )
    {
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      var txmsg = new Message();
      txmsg.Complete = complete;

      return Port.Transmit ( txmsg, DevicePort.DefaultReadDelay );
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    }
  }
}
