﻿//-----------------------------------------------------------------------------
// ACI PIM CPN Sensor sample program
// Cpn sensor device library
//-----------------------------------------------------------------------------
// 2020 Analytical Control Instruments GmbH
//-----------------------------------------------------------------------------


using System.ComponentModel;
using Cpn.Sensor.Communication;


namespace Cpn.Sensor
{
  public partial class Device : Component
    {
    public Device ( string portname )
    {
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      Port = new DevicePort ( portname );
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    }


    public readonly DevicePort Port;


    public void Connect ()
    {
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      Port.Open ();
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    }


    public void Disconnect ()
    {
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      Port.Close ();
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    }


    protected override void Dispose ( bool disposing )
    {
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      Disconnect ();
      base.Dispose ( disposing );
      //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    }
  }
}
